#-----------------------------------------------------------------------------
# Version: 0.1.0b
# Compatible: SketchUp 7 (PC)
#             (other versions untested)
#-----------------------------------------------------------------------------
#
# CHANGELOG
# 0.1.0b - xx.xx.2010
#		 * ...
#
#-----------------------------------------------------------------------------
#
# Thomas Thomassen
# thomas[at]thomthom[dot]net
#
#-----------------------------------------------------------------------------

require 'sketchup.rb'

#-----------------------------------------------------------------------------

module TT_Untitled
	
	### MENU & TOOLBARS ### --------------------------------------------------
	
	unless file_loaded?( File.basename(__FILE__) )
		plugin_menu = UI.menu('Tools')
		plugin_menu.add_item('Adjust Edges')		{ self.start_tool }
	end
	
	
	### MAIN SCRIPT ### ------------------------------------------------------

	def self.start_tool
		Sketchup.active_model.tools.push_tool(AdjustEdges.new)
	end
  
  
  class AdjustEdges
    def activate
      @edges = Sketchup.active_model.selection.select{|e|e.is_a?(Sketchup::Edge)}
      Sketchup.vcb_label = 'Length:'
      Sketchup.active_model.start_operation('Adjust Edges')
      select_next_edge()
    end
    
    def deactivate(view)
      Sketchup.active_model.commit_operation
    end
    
    def select_next_edge
      @edge = @edges.shift
      if @edge
        Sketchup.active_model.selection.clear
        Sketchup.active_model.selection.add(@edge)
        Sketchup.vcb_value = @edge.length.to_s
      else
        Sketchup.active_model.tools.pop_tool
      end
    end
    
    def enableVCB?
      true
    end
    
    def onUserText(text, view)
      length = text.to_l
      
      scale = length / @edge.length
      t = Geom::Transformation.scaling(@edge.start.position, scale)
      view.model.active_entities.transform_entities(t, @edge)
      
      select_next_edge()
    end
  end

	
	### HELPER METHODS ### ---------------------------------------------------
	
	def self.start_operation(name)
		model = Sketchup.active_model
		if Sketchup.version.split('.')[0].to_i >= 7
			model.start_operation(name, true)
		else
			model.start_operation(name)
		end
	end
	
end # module

#-----------------------------------------------------------------------------
file_loaded( File.basename(__FILE__) )
#-----------------------------------------------------------------------------